> ## Documentation Index
> Fetch the complete documentation index at: https://glide-file-upload-from-source-url.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Add Rows to Table

> Adds rows to a Big Table

Add one or more rows to an existing Big Table.

Row IDs for the added rows are returned in the response in the same order as the input row data is passed in the request. Row data may be passed in JSON, CSV, or TSV format.

If a column is not included in the passed row data, it will be empty in the added row. If a column is passed that does not exist in the table schema, or with a value that does not match the column's type, the default behavior is for no rows to be added and the API call to [return an error](/api-reference/v2/general/errors#invalid-row-data). However, you can control this behavior with the `onSchemaError` query parameter.

## Examples

<AccordionGroup>
  <Accordion title="Add Rows Inline">
    If you want to add a small number of rows to a table, you can do so by providing the data inline (being sure that row object structure matches the table schema):

    ```json theme={null}
    [
      {
        "fullName": "Alex Bard",
        "ageInYears": 30,
        "hiredOn": "2021-07-03"
      }, {
        "fullName": "Alicia Hines",
        "ageInYears": 34,
        "hiredOn": "2023-01-015"
      }
    ]
    ```

    However, this is only appropriate for relatively small dataset (a few hundred rows or less, depending on schema complexity). If you need to work with a larger dataset you should utilize stashing.
  </Accordion>

  <Accordion title="Add Rows from Stash">
    [Stashing](/api-reference/v2/stashing/introduction) is our process for handling the upload of large datasets. Break down your dataset into smaller, more manageable, pieces and [upload them to a single stash ID](/api-reference/v2/stashing/put-stashes-serial).

    Then, to add all the row data in a stash to the table in a single atomic operation, use the `$stashID` reference in the `rows` field instead of providing the data inline:

    ```json theme={null}
    {
        "$stashID": "20240215-job32"
    }
    ```
  </Accordion>
</AccordionGroup>
